#include <struct.h>
#include <stdio.h>
#include "edbproc.h"	/* this should be empty for the server */
#include "misc.h"
#include "var.h"
#include "xy.h"
#include "loan.h"
#include "nsc.h"
#include "edb.h"
#include "news.h"
#include "nuke.h"
#include "plane.h"
#include "ship.h"
#include "land.h"
#include "sect.h"
#include "trade.h"
#include "treaty.h"
#include "genitem.h"
#include "nat.h"
#include "map.h"

/* NSC table definition  for unknown */
struct castr Object_type_337[] = { /* 337 */
	NSC_UCHAR | fldoff(Object_type_337_ca, fld_owner           ), "owner",0,0,
	NSC_SHORT | fldoff(Object_type_337_ca, fld_uid             ), "uid",0,0,
	NSC_SHORT | fldoff(Object_type_337_ca, fld_xloc            ), "xloc",0,0,
	NSC_SHORT | fldoff(Object_type_337_ca, fld_yloc            ), "yloc",0,0,
	NSC_UCHAR | fldoff(Object_type_337_ca, fld_type            ), "type",0,0,
	NSC_UCHAR | fldoff(Object_type_337_ca, fld_effic           ), "effic",0,0,
	NSC_CHARP | fldoff(Object_type_337_ca, fld_mobil           ), "mobil",0,0,
	NSC_SHORT | fldoff(Object_type_337_ca, fld_sell            ), "sell",0,0,
	NSC_SHORT | fldoff(Object_type_337_ca, fld_tech            ), "tech",0,0,
	NSC_CHARP | fldoff(Object_type_337_ca, fld_group           ), "group",0,0,
	NSC_SHORT | fldoff(Object_type_337_ca, fld_opx             ), "opx",0,0,
	NSC_SHORT | fldoff(Object_type_337_ca, fld_opy             ), "opy",0,0,
	NSC_SHORT | fldoff(Object_type_337_ca, fld_mission         ), "mission",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_pstage          ), "pstage",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_ptime           ), "ptime",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_che             ), "che",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_civil           ), "civil",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_milit           ), "milit",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_shell           ), "shell",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_gun             ), "gun",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_petrol          ), "petrol",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_iron            ), "iron",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_dust            ), "dust",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_bar             ), "bar",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_food            ), "food",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_oil             ), "oil",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_lcm             ), "lcm",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_hcm             ), "hcm",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_uw              ), "uw",0,0,
	NSC_USHORT| fldoff(Object_type_337_ca, fld_rad             ), "rad",0,0,
	0,0,0,0
};

/* NSC table definition  for version */
struct castr gameinfo_ca[] = { /* 208 */
	NSC_INT   | fldoff(gameinfo, fld_MAXNOC          ), "MAXNOC",0,0,
	NSC_INT   | fldoff(gameinfo, fld_WORLD_X         ), "WORLD_X",0,0,
	NSC_INT   | fldoff(gameinfo, fld_WORLD_Y         ), "WORLD_Y",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_data            ), "data",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_info            ), "info",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_port            ), "port",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_privname        ), "privname",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_privlog         ), "privlog",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_btu_build_rate  ), "btu_build_rate",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_easy_tech       ), "easy_tech",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_hard_tech       ), "hard_tech",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_start_tech      ), "start_tech",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_start_happy     ), "start_happy",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_start_research  ), "start_research",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_start_edu       ), "start_edu",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_land_mob_scale  ), "land_mob_scale",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_level_age_rate  ), "level_age_rate",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_plane_mob_scale ), "plane_mob_scale",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_sect_mob_scale  ), "sect_mob_scale",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_ship_mob_scale  ), "ship_mob_scale",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_tech_log_base   ), "tech_log_base",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_ally_factor     ), "ally_factor",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_edu_avg         ), "edu_avg",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_hap_avg         ), "hap_avg",0,0,
	NSC_INT   | fldoff(gameinfo, fld_startmob        ), "startmob",0,0,
	NSC_INT   | fldoff(gameinfo, fld_at_least_one_100), "at_least_one_100",0,0,
	NSC_INT   | fldoff(gameinfo, fld_buil_bh         ), "buil_bh",0,0,
	NSC_INT   | fldoff(gameinfo, fld_etu_per_update  ), "etu_per_update",0,0,
	NSC_INT   | fldoff(gameinfo, fld_land_grow_scale ), "land_grow_scale",0,0,
	NSC_INT   | fldoff(gameinfo, fld_land_mob_max    ), "land_mob_max",0,0,
	NSC_INT   | fldoff(gameinfo, fld_m_m_p_d         ), "m_m_p_d",0,0,
	NSC_INT   | fldoff(gameinfo, fld_max_btus        ), "max_btus",0,0,
	NSC_INT   | fldoff(gameinfo, fld_max_idle        ), "max_idle",0,0,
	NSC_INT   | fldoff(gameinfo, fld_plane_grow_scale), "plane_grow_scale",0,0,
	NSC_INT   | fldoff(gameinfo, fld_plane_mob_max   ), "plane_mob_max",0,0,
	NSC_INT   | fldoff(gameinfo, fld_players_at_00   ), "players_at_00",0,0,
	NSC_INT   | fldoff(gameinfo, fld_sect_mob_max    ), "sect_mob_max",0,0,
	NSC_INT   | fldoff(gameinfo, fld_ship_grow_scale ), "ship_grow_scale",0,0,
	NSC_INT   | fldoff(gameinfo, fld_ship_mob_max    ), "ship_mob_max",0,0,
	NSC_INT   | fldoff(gameinfo, fld_torpedo_damage  ), "torpedo_damage",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_buytax          ), "buytax",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_flakscale       ), "flakscale",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_maxmult         ), "maxmult",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_minmult         ), "minmult",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_tradetax        ), "tradetax",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_uwbrate         ), "uwbrate",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_buil_bc         ), "buil_bc",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_buil_bt         ), "buil_bt",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_combat_mob      ), "combat_mob",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_edu_cons        ), "edu_cons",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_hap_cons        ), "hap_cons",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_money_civ       ), "money_civ",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_money_land      ), "money_land",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_money_mil       ), "money_mil",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_money_plane     ), "money_plane",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_money_res       ), "money_res",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_money_ship      ), "money_ship",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_money_uw        ), "money_uw",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_people_damage   ), "people_damage",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_powe_cost       ), "powe_cost",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_unit_damage     ), "unit_damage",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_collateral_dam  ), "collateral_dam",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_assault_penalty ), "assault_penalty",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_babyeat         ), "babyeat",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_bankint         ), "bankint",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_eatrate         ), "eatrate",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_fcrate          ), "fcrate",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_fgrate          ), "fgrate",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_obrate          ), "obrate",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_mission_mob_cost), "mission_mob_cost",0,0,
	NSC_LONG  | fldoff(gameinfo, fld_adj_update      ), "adj_update",0,0,
	NSC_LONG  | fldoff(gameinfo, fld_s_p_etu         ), "s_p_etu",0,0,
	NSC_INT   | fldoff(gameinfo, fld_fuel_mult       ), "fuel_mult",0,0,
	NSC_LONG  | fldoff(gameinfo, fld_last_demand_update), "last_demand_update",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_drnuke_const    ), "drnuke_const",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_fire_range_factor), "fire_range_factor",0,0,
	NSC_INT   | fldoff(gameinfo, fld_morale_base     ), "morale_base",0,0,
	NSC_INT   | fldoff(gameinfo, fld_sect_mob_neg_factor), "sect_mob_neg_factor",0,0,
	NSC_INT   | fldoff(gameinfo, fld_trade_1_dist    ), "trade_1_dist",0,0,
	NSC_INT   | fldoff(gameinfo, fld_trade_2_dist    ), "trade_2_dist",0,0,
	NSC_INT   | fldoff(gameinfo, fld_trade_3_dist    ), "trade_3_dist",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_trade_1         ), "trade_1",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_trade_2         ), "trade_2",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_trade_3         ), "trade_3",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_trade_ally_bonus), "trade_ally_bonus",0,0,
	NSC_FLOAT | fldoff(gameinfo, fld_trade_ally_cut  ), "trade_ally_cut",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_NEW_MOB         ), "NEW_MOB",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_MOB_ACCESS      ), "MOB_ACCESS",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_EURO            ), "EURO",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_RESEARCH        ), "RESEARCH",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_LOANS           ), "LOANS",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_MARKET          ), "MARKET",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_NOFOOD          ), "NOFOOD",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_SNEAK_ATTACK    ), "SNEAK_ATTACK",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_BLITZ           ), "BLITZ",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_HIDDEN          ), "HIDDEN",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_LOSE_CONTACT    ), "LOSE_CONTACT",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_NONUKES         ), "NONUKES",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_FUEL            ), "FUEL",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_TRADESHIPS      ), "TRADESHIPS",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_NEWPOWER        ), "NEWPOWER",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_NOMOBCOST       ), "NOMOBCOST",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_SUPER_BARS      ), "SUPER_BARS",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_EASY_BRIDGES    ), "EASY_BRIDGES",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_ALL_BLEED       ), "ALL_BLEED",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_DRNUKE          ), "DRNUKE",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_SLOW_WAR        ), "SLOW_WAR",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_PLAGUE          ), "PLAGUE",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_NEW_STARVE      ), "NEW_STARVE",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_NEW_WORK        ), "NEW_WORK",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_RES_POP         ), "RES_POP",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_GRAB_THINGS     ), "GRAB_THINGS",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_SHOWPLANE       ), "SHOWPLANE",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_ORBIT           ), "ORBIT",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_PINPOINTMISSILE ), "PINPOINTMISSILE",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_FALLOUT         ), "FALLOUT",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_SAIL            ), "SAIL",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_NUKEFAILDETONATE), "NUKEFAILDETONATE",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_SHIPNAMES       ), "SHIPNAMES",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_NEUTRON         ), "NEUTRON",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_UPDATESCHED     ), "UPDATESCHED",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_DEMANDUPDATE    ), "DEMANDUPDATE",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_BIG_CITY        ), "BIG_CITY",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_INTERDICT_ATT   ), "INTERDICT_ATT",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_FORTFIRE        ), "FORTFIRE",0,0,
	NSC_CHARP | fldoff(gameinfo, fld_BIGSTART        ), "BIGSTART",0,0,
	0,0,0,0
};


/* NSC table definition  for bmap */
struct castr bmpstr_ca[] = { /* 332 */
	NSC_UCHAR | fldoff(bmpstr, bmp_own             ), "own",0,0,
	NSC_SHORT | fldoff(bmpstr, bmp_leftx           ), "leftx",0,0,
	NSC_SHORT | fldoff(bmpstr, bmp_rightx          ), "rightx",0,0,
	NSC_SHORT | fldoff(bmpstr, bmp_y               ), "y",0,0,
	NSC_CHAR  | fldoff(bmpstr, bmp_row[0]          ), "row",WORLD_X/2+1,0,
	0,0,0,0
};

/* NSC table definition  for map */
struct castr mapstr_ca[] = { /* 331 */
	NSC_SHORT | fldoff(mapstr, map_x               ), "x",0,0,
	NSC_SHORT | fldoff(mapstr, map_y               ), "y",0,0,
	NSC_CHARP | fldoff(mapstr, map_des             ), "des",0,0,
	0,0,0,0
};

